clear

if (Test-Path .\history.log) {
} else {
    Write-Host "Cannot find history.log. Make sure you are running this script from its location on the psimage network share."
    Write-Host 'Right-click search_history.ps1 and choose "Run with PowerShell"'
    Read-Host -Prompt "Press Enter to quit"
    exit
}

Set-Location $PSScriptRoot
$global:search_string=""

function search_history {
    Write-Output 'Imaging history search. Search is case insensitive. Enter "quit" to exit.'
    $search_string=Read-Host -Prompt "Serial number, computer name, image name, or date (MM/DD/YYYY) to search for"
    if ($search_string -match "quit") {exit}

    Write-Output ""

    $log_file=".\history.log"

    Get-Content $log_file -First 1 > .\temp.txt
    Get-Content $log_file -ReadCount 1000 | ForEach {$_ -match "$search_string"} >> .\temp.txt

    Write-Output ""

    Import-CSV .\temp.txt | Format-Table
    Remove-Item .\temp.txt
}

do {
    search_history
}
while ($search_string -notmatch "quit")
