clear

if (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator")) {
    Write-Output "Insufficient permissions to run this script. Open the PowerShell console as an administrator and run this script again."
    Read-Host -Prompt "Press Enter to exit"
    exit
}

if (Test-Path .\ReadMe.txt) {
} else {
    Write-Host "This script cannot be run locally but must be run from the psimage network share"
    Read-Host -Prompt "Press Enter to quit"
    exit
}

#If OS is Windows 11 nag user to install all updates. Otherwise sysprep will fail due to reserve storage being in use.
$OS_release=((Get-ItemProperty -Path "HKLM:\Software\Microsoft\Windows NT\CurrentVersion").BuildLabEx).split(".")[3]
if ($OS_release -match "co_release") {
    wmic qfe get hotfixid > c:\windows\temp\hotfix_list.txt
    (Get-Content c:\windows\temp\hotfix_list.txt) | Where-Object {$_.trim() -ne ""} | set-content c:\windows\temp\hotfix_list.txt
    $patch_count=Get-Content c:\windows\temp\hotfix_list.txt | Measure-Object -Line
    if ($patch_count.Lines -gt 1) {
        Write-Output "Windows 11 believes it is missing the following OS updates, which block sysprep."
        cat c:\windows\temp\hotfix_list.txt
        Write-Output "Please install the above Windows 11 OS updates to release reserved storage and prevent sysprep from failing."
        Write-Output "If you have already installed all OS updates then ignore this message."
    }
    Remove-Item c:\windows\temp\hotfix_list.txt
}

$username=$env:USERNAME

Set-Location $PSScriptRoot
if ((Get-LocalUser | Select Name) -match "fwadmin") {
    Write-Output "Imaging account fwadmin already exists."
    if (Test-Path "C:\Users\fwadmin") {
        Write-Output "fwadmin user has logged in at least once."
        if (Test-Path .\unattend.xml) {
            if ($username -match "fwadmin") {
                Write-Host "Current user is fwadmin. Must sysprep as default admin user instead of fwadmin."
                Write-Host "Log out, log back in as default admin user, and re-run this script again."
                Write-Host ""
                exit
            }
            Write-Output "Found unattend.xml. Will sysprep system using this answer file for image capture."
            Copy-Item -Path .\unattend.xml -Destination c:\Windows\System32\Sysprep
            Read-Host -Prompt "System will shut down after sysprep. Press Enter to begin sysprep"
            #sysprep fails on Windows 11 if triggered via script that resides on network share. Set location to local drive before triggering sysprep.
            Set-Location -Path "c:\Windows\System32\Sysprep"
            c:\Windows\System32\Sysprep\sysprep.exe /generalize /oobe /shutdown /unattend:c:\Windows\System32\Sysprep\unattend.xml
        } else {
            Write-Output "Cannot find unattend.xml. Add unattend.xml answer file to sysprep folder on psimage share or folder on USB thumb drive."
            Write-Output "Run this script again once you've added an unattend.xml file."
            Write-Output ""
            exit
        }
    } else {
        Write-Output 'fwadmin has not yet logged in. Log in at least once using the fwadmin account with "filewave" for the password.'
        Write-Output "Then log back in with your default local admin account and re-run this script again to sysprep for image capture."
        Write-Output ""
    }
} else {
    Write-Output "Imaging account fwadmin does not exist. Creating account and adding to local Administrators group."
    $Secure_String_Pwd = ConvertTo-SecureString "filewave" -AsPlainText -Force
    New-LocalUser -Name "fwadmin" -Password $Secure_String_Pwd -AccountNeverExpires -PasswordNeverExpires | Out-Null
    Add-LocalGroupMember -Group "Administrators" -Member "fwadmin"
    Write-Output 'Please log out and log back in using the fwadmin account with "filewave" for the password one time.'
    Write-Output "Then log back in with your default local admin account and re-run this script again to sysprep for image capture."
    Write-Output ""
}