clear

if (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator")) {
    Write-Output "Insufficient permissions to run this script. Open the PowerShell console as an administrator and run this script again."
    Read-Host -Prompt "Press Enter to exit"
    exit
}

function main_menu ($status) {
    Write-Output ""
    Write-Output "Remove apps that are installed for a user, but not provisioned for all users to prevent sysprep errors"
    Write-Output ""
    Write-Output "1. View Windows setuperr.log"
    Write-Output "2. List apps"
    Write-Output "3. Remove app for all users"
    Write-Output "4. Quit"
    Write-Output ""
}

function list_apps {
    $app_name=Read-Host "Enter name of app to check if installed (no spaces allowed)"
    Get-AppxPackage -allusers "*$app_name*" | foreach { $_.Name } | Out-File .\temp.txt
    cat .\temp.txt
    Remove-Item .\temp.txt
}

function remove_app {
    $app_name=Read-Host "Enter name of app to be removed (no spaces allowed)"
    Get-AppxPackage -allusers "*$app_name*" | foreach { $_.Name } | Out-File .\temp.txt
    Write-Output ""
    Write-Output "The following apps will be removed for all users"
    cat .\temp.txt
    Remove-Item .\temp.txt
    Write-Output ""
    $answer=Read-Host "Enter yes to to confirm removal of above apps"
    if ($answer -match "yes") {
        Get-AppxPackage -allusers "*$app_name*" | Remove-AppxPackage
    } else {
        Write-Output "No apps were removed"
    }
}

while ($choice -notmatch "4") {
    main_menu
    $choice = Read-Host -Prompt "What do you want to do"

    switch ($choice)
    {
        1 {
            Write-Host ""
            cat c:\windows\system32\sysprep\panther\setuperr.log
        }
        2 {
            Write-Output ""
            list_apps
        }
        3 {
            Write-Output ""
            remove_app
        }
        4 {
            Write-Output ""
            exit
        }
    }
    Write-Host ""
}